# Each new term in the Fibonacci sequence is generated by adding the previous two terms.
# By starting with 1 and 2, the first 10 terms will be:
# 
#   1, 2, 3, 5, 8, 13, 21, 34, 55, 89, ...
# 
# By considering the terms in the Fibonacci sequence whose values do not exceed four million, 
# find the sum of the even-valued terms.


def fib(n):
    sqrt5 = 5 ** (1 / 2)
    phi = (1 + sqrt5) / 2
    psy = (1 - sqrt5) / 2

    return round((phi ** (n + 1) - psy ** (n + 1)) / sqrt5)

def fib_inverse(f):
    n = 1
    while True:
        if fib(n) > f:
            return n - 1 
        n += 1


def solution(f):
    n = fib_inverse(f)
    even_n = filter(lambda x: (x - 2) % 3 == 0, [i for i in range(n + 1)])
    return sum(map(fib, even_n))


print(solution(4_000_000))
